<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'BySolutionLink',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <SlpContainer
    class="by-solution-link"
    data-aos="fade-up"
    :data-aos-duration="500"
  >
    <SlpRow :class="data?.image_right ? 'by-solution-link--reverse' : ''">
      <SlpColumn v-if="data.image" class="left" :cols="data?.size ? 4 : 5">
        <img
          class="by-solution-link__image"
          :src="data.image"
          :alt="data.alt"
          loading="lazy"
        />
      </SlpColumn>
      <SlpColumn class="right" :cols="!data.image ? 12 : data?.size ? 8 : 7">
        <SlpIcon
          :name="data.icon || 'calendar-alt-2'"
          alt="Icon"
          size="md"
          class="slp-mb-16"
          variant="marketing"
        />
        <SlpTypography v-if="data.type" variant="body1-bold" class="slp-my-8">
          {{ data.type }}
        </SlpTypography>
        <SlpTypography
          variant="heading3-bold"
          :class="data?.image_right ? '' : 'slp-mt-24'"
          >{{ data.title }}</SlpTypography
        >

        <div
          v-if="data.description"
          variant="body1"
          class="slp-mt-24"
          v-html="$md.render(data.description)"
        ></div>
        <SlpButton
          class="slp-mt-24"
          :href="data.link"
          :variant="data?.button_type ? data.button_type : 'tertiary'"
          :data-ga-name="
            data?.button_data_ga_name?.toLowerCase() || 'Learn More'
          "
          data-ga-location="body"
        >
          <span
            class="slp-mr-8"
            v-html="data?.button_text ? data.button_text : 'Learn More'"
          ></span>
          <SlpIcon
            name="chevron-lg-right"
            variant="product"
            hex-color="#171321"
            alt="Chevron Right Icon"
          />
        </SlpButton>
      </SlpColumn>
    </SlpRow>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.by-solution-link {
  margin: $spacing-96 auto;

  @media (max-width: $breakpoint-md) {
    margin-top: $spacing-64;
  }

  .left {
    .by-solution-link {
      width: 100%;
      height: 100%;
    }
  }

  &__image {
    min-height: 100%;
    max-width: 100%;
    border-radius: $spacing-4 0 0 $spacing-4;
    object-fit: cover;
  }

  .right {
    padding: $spacing-48;
    display: flex;
    flex-direction: column;
    background-color: $color-surface-800;
    border-radius: 0 4px 100px 0;
  }

  &--reverse {
    flex-direction: row-reverse;

    .right {
      justify-content: center;
      border-radius: 4px 0 0 4px;

      @media (max-width: $breakpoint-md) {
        border-radius: 0 0 4px 4px;
      }

      .slp-btn-primary {
        max-width: fit-content;
      }
    }

    .left {
      img {
        border-radius: 0 4px 100px 0;

        @media (max-width: $breakpoint-md) {
          border-radius: 4px 4px 0 0;
        }
      }
    }
  }
}
</style>
